window.ccSpinnerControl = class ccSpinnerControl									# Set to Window so Jasmine works.

  _create: ->  																	# JQuery UI Widget Create Method.  (Runs first)
  
    inputTag = ($ '<input/>')													# Create Input HTML Snippit
      .attr(id: @options.Name)
      .attr(type: 'text')
      .attr(value: @options.DefaultValue)  
        
    controls = ($ '<div/>')														# Create Control HTML Snippit
      .addClass(@css.Controls)
      .append(($ '<a/>').attr(href: 'javascript:void(0);').addClass(@css.Up))
      .append(($ '<a/>').attr(href: 'javascript:void(0);').addClass(@css.Down))   

    ($ this.element).addClass(@css.Spinner)                         # Insert CSS Clas

    ($ this.element).append(inputTag).append(controls)							# Insert HTML Snippits
    
   
  _init: ->   																	# JQuery UI Widget Init method.  (Runs after _create)   
    divControl = ($ '#' + @options.Name).next()
    ($ '.' + @css.Up, divControl).click => @Up()								# Add Click Handler for Up
    ($ '.' + @css.Down, divControl).click => @Down()							# Add Click Handler for Down
         
         
  Up: ->
    newValue = @GetValue() + @options.IncrementBy
    if newValue > @options.Max then @SetValue @options.Min else @SetValue newValue   
    
    
  Down: ->
    newValue = @GetValue() - @options.IncrementBy
    if newValue < @options.Min then @SetValue @options.Max else @SetValue newValue
    
    
  GetValue: ->
    +($ '#' + @options.Name).val()												# Return Value of input converted to number.
  
  
  SetValue: (value) ->
    ($ '#' + @options.Name).val +value                                      	# Set Value to input ensured value is number.


  options: 																		# Widget Options
    Name: "Default"
    DefaultValue: 0
    IncrementBy: 1
    Min: 0
    Max: 10


  css:																			# CSS Names
    Spinner: "ccSpinner"
    Up: 'ccSpinnerUp'
    Down: 'ccSpinnerDown'
    Controls: 'ccSpinnerControls'
  
$.widget "cc.ccSpinner", new ccSpinnerControl    									# Declare the Widget

  
  