(function() {
  var ccSpinnerControl;

  window.ccSpinnerControl = ccSpinnerControl = (function() {

    function ccSpinnerControl() {}

    ccSpinnerControl.prototype._create = function() {
      var controls, inputTag;
      inputTag = ($('<input/>')).attr({
        id: this.options.Name
      }).attr({
        type: 'text'
      }).attr({
        value: this.options.DefaultValue
      });
      controls = ($('<div/>')).addClass(this.css.Controls).append(($('<a/>')).attr({
        href: 'javascript:void(0);'
      }).addClass(this.css.Up)).append(($('<a/>')).attr({
        href: 'javascript:void(0);'
      }).addClass(this.css.Down));
      ($(this.element)).addClass(this.css.Spinner);
      return ($(this.element)).append(inputTag).append(controls);
    };

    ccSpinnerControl.prototype._init = function() {
      var divControl,
        _this = this;
      divControl = ($('#' + this.options.Name)).next();
      ($('.' + this.css.Up, divControl)).click(function() {
        return _this.Up();
      });
      return ($('.' + this.css.Down, divControl)).click(function() {
        return _this.Down();
      });
    };

    ccSpinnerControl.prototype.Up = function() {
      var newValue;
      newValue = this.GetValue() + this.options.IncrementBy;
      if (newValue > this.options.Max) {
        return this.SetValue(this.options.Min);
      } else {
        return this.SetValue(newValue);
      }
    };

    ccSpinnerControl.prototype.Down = function() {
      var newValue;
      newValue = this.GetValue() - this.options.IncrementBy;
      if (newValue < this.options.Min) {
        return this.SetValue(this.options.Max);
      } else {
        return this.SetValue(newValue);
      }
    };

    ccSpinnerControl.prototype.GetValue = function() {
      return +($('#' + this.options.Name)).val();
    };

    ccSpinnerControl.prototype.SetValue = function(value) {
      return ($('#' + this.options.Name)).val(+value);
    };

    ccSpinnerControl.prototype.options = {
      Name: "Default",
      DefaultValue: 0,
      IncrementBy: 1,
      Min: 0,
      Max: 10
    };

    ccSpinnerControl.prototype.css = {
      Spinner: "ccSpinner",
      Up: 'ccSpinnerUp',
      Down: 'ccSpinnerDown',
      Controls: 'ccSpinnerControls'
    };

    return ccSpinnerControl;

  })();

  $.widget("cc.ccSpinner", new ccSpinnerControl);

}).call(this);
