describe "SpinnerControl", ->

  describe "Set Options", ->
  
    beforeEach ->
      @control = new ccSpinnerControl
      @control.options = 
        Name: "SpinInt1"
        DefaultValue: 10
        IncrementBy: 5
        Min: 0
        Max: 20
      @control._create()
    
   
    it "extracts name", ->
    	expect(@control.options.Name).toEqual 'SpinInt1'
    
    it "extracts DefaultValue", ->
      expect(@control.options.DefaultValue).toEqual 10
    
    it "extracts IncrementBy", ->
      expect(@control.options.IncrementBy).toEqual 5
    
    it "extracts Min", ->
      expect(@control.options.Min).toEqual 0
    
    it "extracts Max", ->
      expect(@control.options.Max).toEqual 20
      
  describe "Initialized Widget", ->
  
  	it "Id should be selectable and have default value", ->
  	  setFixtures("<div class='Spinner'></div>")
  	  @options = 
  	    Name: "SpinInt1"
  	    DefaultValue: 10
  	    IncrementBy: 5
  	    Min: 0
  	    Max: 20
  	  ($ '.Spinner').ccSpinner(@options)
  	  expect(($ '#SpinInt1')).toHaveValue 10
  	  
  	it "Value should increase by IncrementBy", ->
  	  setFixtures("<div class='Spinner'></div>")
  	  @options = 
  	    Name: "SpinInt1"
  	    DefaultValue: 10
  	    IncrementBy: 5
  	    Min: 0
  	    Max: 20
  	  ($ '.Spinner').ccSpinner(@options)
  	  # TODO: Somehow have to use a Jasmine Spy to trigger the onclick and test that.  Don't know how to do that yet.
  	  
  	  
  	# TODO: We need to test the UP and Down items.  Don't know how to do that yet.  

	 
  	  
  	
  	  
  	  



  	  