(function() {

  describe("SpinnerControl", function() {
    describe("Set Options", function() {
      beforeEach(function() {
        this.control = new ccSpinnerControl;
        this.control.options = {
          Name: "SpinInt1",
          DefaultValue: 10,
          IncrementBy: 5,
          Min: 0,
          Max: 20
        };
        return this.control._create();
      });
      it("extracts name", function() {
        return expect(this.control.options.Name).toEqual('SpinInt1');
      });
      it("extracts DefaultValue", function() {
        return expect(this.control.options.DefaultValue).toEqual(10);
      });
      it("extracts IncrementBy", function() {
        return expect(this.control.options.IncrementBy).toEqual(5);
      });
      it("extracts Min", function() {
        return expect(this.control.options.Min).toEqual(0);
      });
      return it("extracts Max", function() {
        return expect(this.control.options.Max).toEqual(20);
      });
    });
    return describe("Initialized Widget", function() {
      it("Id should be selectable and have default value", function() {
        setFixtures("<div class='Spinner'></div>");
        this.options = {
          Name: "SpinInt1",
          DefaultValue: 10,
          IncrementBy: 5,
          Min: 0,
          Max: 20
        };
        ($('.Spinner')).ccSpinner(this.options);
        return expect($('#SpinInt1')).toHaveValue(10);
      });
      return it("Value should increase by IncrementBy", function() {
        setFixtures("<div class='Spinner'></div>");
        this.options = {
          Name: "SpinInt1",
          DefaultValue: 10,
          IncrementBy: 5,
          Min: 0,
          Max: 20
        };
        return ($('.Spinner')).ccSpinner(this.options);
      });
    });
  });

}).call(this);
